Properties Methods Events Config Options Direct Link

    DragDrop
      DDTarget
        DropTarget
          DropZone

# Class Ext.dd.DropZone

Package: | Ext.dd
Defined In: | DropZone.js
Class: | DropZone
Subclasses: | TreeDropZone
Extends: | DropTarget

This class provides a container DD instance that allows dropping on multiple child target nodes.

By default, this class requires that child nodes accepting drop are registered with Ext.dd.Registry. However a simpler way to allow a DropZone to manage any number of target elements is to configure the DropZone with an implementation of getTargetFromEvent which interrogates the passed mouse event to see if it has taken place within an element, or class of elements. This is easily done by using the event's getTarget method to identify a node based on a Ext.DomQuery selector.

Once the DropZone has detected through calling getTargetFromEvent, that the mouse is over a drop target, that target is passed as the first parameter to onNodeEnter, onNodeOver, onNodeOut, onNodeDrop. You may configure the instance of DropZone with implementations of these methods to provide application-specific behaviour for these events to update both application state, and UI state.

For example to make a GridPanel a cooperating target with the example illustrated in DragZone, the following technique might be used:

    myGridPanel.on('render', function() {
        myGridPanel.dropZone = new Ext.dd.DropZone(myGridPanel.getView().scroller, {

    //      If the mouse is over a grid row, return that node. This is
    //      provided as the "target" parameter in all "onNodeXXXX" node event handling functions
            getTargetFromEvent: function(e) {
                return e.getTarget(myGridPanel.getView().rowSelector);
            },

    //      On entry into a target node, highlight that node.
            onNodeEnter : function(target, dd, e, data){
                Ext.fly(target).addClass('my-row-highlight-class');
            },

    //      On exit from a target node, unhighlight that node.
            onNodeOut : function(target, dd, e, data){
                Ext.fly(target).removeClass('my-row-highlight-class');
            },

    //      While over a target node, return the default drop allowed class which
    //      places a "tick" icon into the drag proxy.
            onNodeOver : function(target, dd, e, data){
                return Ext.dd.DropZone.prototype.dropAllowed;
            },

    //      On node drop we can interrogate the target to find the underlying
    //      application object that is the real target of the dragged data.
    //      In this case, it is a Record in the GridPanel's Store.
    //      We can use the data set up by the DragZone's getDragData method to read
    //      any data we decided to attach in the DragZone's getDragData method.
            onNodeDrop : function(target, dd, e, data){
                var rowIndex = myGridPanel.getView().findRowIndex(target);
                var r = myGridPanel.getStore().getAt(rowIndex);
                Ext.Msg.alert('Drop gesture', 'Dropped Record id ' + data.draggedRecord.id +
                    ' on Record id ' + r.id);
                return true;
            }
        });
    }

See the DragZone documentation for details about building a DragZone which cooperates with this DropZone.

## Config Options

Config Options | Defined By
--- | ---
| ddGroup : String A named drag drop group to which this object belongs. If a group is specified, then this object will only interact w... A named drag drop group to which this object belongs. If a group is specified, then this object will only interact with other drag drop objects in the same group (defaults to undefined). | DropTarget
| dropAllowed : String The CSS class returned to the drag source when drop is allowed (defaults to "x-dd-drop-ok"). | DropTarget
| dropNotAllowed : String The CSS class returned to the drag source when drop is not allowed (defaults to "x-dd-drop-nodrop"). | DropTarget
| overClass : String The CSS class applied to the drop target element while the drag source is over it (defaults to ""). | DropTarget

## Public Properties

Property | Defined By
--- | ---
| available : boolean The available property is false until the linked dom element is accessible. | DragDrop
| config : object Configuration attributes passed into the constructor | DragDrop
| defaultPadding : Object Provides default constraint padding to "constrainTo" elements (defaults to {left: 0, right:0, top:0, bottom:0}). | DragDrop

groups : object An object in the format {'group1':true, 'group2':true
The group defines a logical collection of DragDrop objects that are related. Instances only get events when interact...
The group defines a logical collection of DragDrop objects that are related. Instances only get events when interacting with other DragDrop object in the same group. This lets us define multiple groups using a single DragDrop subclass if we want.

DragDrop

hasOuterHandles : boolean
By default, drags can only be initiated if the mousedown occurs in the region the linked element is. This is done in...
By default, drags can only be initiated if the mousedown occurs in the region the linked element is. This is done in part to work around a bug in some browsers that mis-report the mousedown if the previous mouseup happened outside of the window. This property is set to true if outer handles are defined.

DragDrop

| id : String The id of the element associated with this object. This is what we refer to as the "linked element" because the size... The id of the element associated with this object. This is what we refer to as the "linked element" because the size and position of this element is used to determine when the drag and drop objects have interacted. | DragDrop
| ignoreSelf : Boolean Set to false to enable a DragDrop object to fire drag events while dragging over its own Element. Defaults to true - ... Set to false to enable a DragDrop object to fire drag events while dragging over its own Element. Defaults to true - DragDrop objects do not by default fire drag events to themselves. | DragDrop
| invalidHandleClasses : Array An Array of CSS class names for elements to be considered in valid as drag handles. | DragDrop

invalidHandleIds : Object
An object who's property names identify the IDs of elements to be considered invalid as drag handles. A non-null prop...
An object who's property names identify the IDs of elements to be considered invalid as drag handles. A non-null property value identifies the ID as invalid. For example, to prevent dragging from being initiated on element ID "foo", use:

    {
        foo: true
    }

DragDrop

invalidHandleTypes : Object
An object who's property names identify HTML tags to be considered invalid as drag handles. A non-null property value...
An object who's property names identify HTML tags to be considered invalid as drag handles. A non-null property value identifies the tag as invalid. Defaults to the following value which prevents drag operations from being initiated by <a> elements:

    {
        A: "A"
    }

DragDrop

| isTarget : boolean By default, all instances can be a drop target. This can be disabled by setting isTarget to false. | DragDrop
| maintainOffset : boolean Maintain offsets when we resetconstraints. Set to true when you want the position of the element relative to its par... Maintain offsets when we resetconstraints. Set to true when you want the position of the element relative to its parent to stay the same when the page changes | DragDrop
| moveOnly : boolean When set to true, other DD objects in cooperating DDGroups do not receive notification events when this DD object is ... When set to true, other DD objects in cooperating DDGroups do not receive notification events when this DD object is dragged over them. Defaults to false. | DragDrop
| padding : int[] An array containing the 4 padding values: [top, right, bottom, left] The padding configured for this drag and drop object for calculating the drop zone intersection with this object. | DragDrop
| primaryButtonOnly : boolean By default the drag and drop instance will only respond to the primary button click (left button for a right-handed m... By default the drag and drop instance will only respond to the primary button click (left button for a right-handed mouse). Set to true to allow drag and drop to start with any mouse click that is propogated by the browser | DragDrop
| xTicks : int[] Array of pixel locations the element will snap to if we specified a horizontal graduation/interval. This array is ge... Array of pixel locations the element will snap to if we specified a horizontal graduation/interval. This array is generated automatically when you define a tick interval. | DragDrop
| yTicks : int[] Array of pixel locations the element will snap to if we specified a vertical graduation/interval. This array is gene... Array of pixel locations the element will snap to if we specified a vertical graduation/interval. This array is generated automatically when you define a tick interval. | DragDrop

## Public Methods

Method | Defined By
--- | ---

DropZone( `Mixed el`, `Object config` )
Parameters:

- `el` : Mixed
  The container element
- `config` : Object

Returns:

- void

DropZone

addToGroup( `sGroup {string}` ) : void
Add this instance to a group of related drag/drop objects. All instances belong to at least one group, and can belon...
Add this instance to a group of related drag/drop objects. All instances belong to at least one group, and can belong to as many groups as needed.
Parameters:

- `{string}` : sGroup
  the name of the group

Returns:

- void

DragDrop

applyConfig() : void
Applies the configuration parameters that were passed into the constructor. This is supposed to happen at each level ...
Applies the configuration parameters that were passed into the constructor. This is supposed to happen at each level through the inheritance chain. So a DDProxy implentation will execute apply config on DDProxy, DD, and DragDrop in order to get all of the parameters that are available in each object.
Parameters:

- None.

Returns:

- void

DragDrop

constrainTo( `Mixed constrainTo`, [`Object/Number pad`], [`Boolean inContent`] ) : void
Initializes the drag drop object's constraints to restrict movement to a certain element. Usage: var dd = new Ext.dd...
Initializes the drag drop object's constraints to restrict movement to a certain element. Usage:

    var dd = new Ext.dd.DDProxy("dragDiv1", "proxytest",
                    { dragElId: "existingProxyDiv" });
     dd.startDrag = function(){
         this.constrainTo("parent-id");
     };

Or you can initalize it using the Ext.Element object:

    Ext.get("dragDiv1").initDDProxy("proxytest", {dragElId: "existingProxyDiv"}, {
         startDrag : function(){
             this.constrainTo("parent-id");
         }
     });

Parameters:

- `constrainTo` : Mixed
  The element to constrain to.
- `pad` : Object/Number
  (optional) Pad provides a way to specify "padding" of the constraints, and can be either a number for symmetrical padding (4 would be equal to {left:4, right:4, top:4, bottom:4}) or an object containing the sides to pad. For example: {right:10, bottom:10}
- `inContent` : Boolean
  (optional) Constrain the draggable in the content box of the element (inside padding and borders)

Returns:

- void

DragDrop

getEl() : HTMLElement
Returns a reference to the linked element
Returns a reference to the linked element
Parameters:

- None.

Returns:

- `HTMLElement`
  the html element

DragDrop

getTargetFromEvent( `Event e` ) : Object
Returns a custom data object associated with the DOM node that is the target of the event. By default this looks up ...
Returns a custom data object associated with the DOM node that is the target of the event. By default this looks up the event target in the Ext.dd.Registry, although you can override this method to provide your own custom lookup.
Parameters:

- `e` : Event
  The event

Returns:

- `Object`
  data The custom data

DropZone

init( `id the`, `String sGroup`, `object config` ) : void
Sets up the DragDrop object. Must be called in the constructor of any Ext.dd.DragDrop subclass
Sets up the DragDrop object. Must be called in the constructor of any Ext.dd.DragDrop subclass
Parameters:

- `the` : id
  id of the linked element
- `sGroup` : String
  the group of related items
- `config` : object
  configuration attributes

Returns:

- void

DragDrop

initTarget( `id the`, `String sGroup`, `object config` ) : void
Initializes Targeting functionality only... the object does not get a mousedown handler.
Initializes Targeting functionality only... the object does not get a mousedown handler.
Parameters:

- `the` : id
  id of the linked element
- `sGroup` : String
  the group of related items
- `config` : object
  configuration attributes

Returns:

- void

DragDrop

isLocked() : boolean
Returns true if this instance is locked, or the drag drop mgr is locked (meaning that all drag/drop is disabled on th...
Returns true if this instance is locked, or the drag drop mgr is locked (meaning that all drag/drop is disabled on the page.)
Parameters:

- None.

Returns:

- `boolean`
  true if this obj or all drag/drop is locked, else false

DragDrop

lock() : void
Lock this instance
Lock this instance
Parameters:

- None.

Returns:

- void

DragDrop

notifyDrop( `Ext.dd.DragSource source`, `Event e`, `Object data` ) : Boolean
The function a Ext.dd.DragSource calls once to notify this drop zone that the dragged item has been dropped on it. T...
The function a Ext.dd.DragSource calls once to notify this drop zone that the dragged item has been dropped on it. The drag zone will look up the target node based on the event passed in, and if there is a node registered for that event, it will delegate to onNodeDrop for node-specific handling, otherwise it will call onContainerDrop.
Parameters:

- `source` : Ext.dd.DragSource
  The drag source that was dragged over this drop zone
- `e` : Event
  The event
- `data` : Object
  An object containing arbitrary data supplied by the drag source

Returns:

- `Boolean`
  True if the drop was valid, else false

DropZone

notifyEnter( `Ext.dd.DragSource source`, `Event e`, `Object data` ) : String
The function a Ext.dd.DragSource calls once to notify this drop zone that the source is now over the zone. The defau...
The function a Ext.dd.DragSource calls once to notify this drop zone that the source is now over the zone. The default implementation returns this.dropNotAllowed and expects that only registered drop nodes can process drag drop operations, so if you need the drop zone itself to be able to process drops you should override this method and provide a custom implementation.
Parameters:

- `source` : Ext.dd.DragSource
  The drag source that was dragged over this drop zone
- `e` : Event
  The event
- `data` : Object
  An object containing arbitrary data supplied by the drag source

Returns:

- `String`
  status The CSS class that communicates the drop status back to the source so that the underlying {@link Ext.dd.StatusProxy} can be updated

DropZone

notifyOut( `Ext.dd.DragSource source`, `Event e`, `Object data` ) : void
The function a Ext.dd.DragSource calls once to notify this drop zone that the source has been dragged out of the zone...
The function a Ext.dd.DragSource calls once to notify this drop zone that the source has been dragged out of the zone without dropping. If the drag source is currently over a registered node, the notification will be delegated to onNodeOut for node-specific handling, otherwise it will be ignored.
Parameters:

- `source` : Ext.dd.DragSource
  The drag source that was dragged over this drop target
- `e` : Event
  The event
- `data` : Object
  An object containing arbitrary data supplied by the drag zone

Returns:

- void

DropZone

notifyOver( `Ext.dd.DragSource source`, `Event e`, `Object data` ) : String
The function a Ext.dd.DragSource calls continuously while it is being dragged over the drop zone. This method will be...
The function a Ext.dd.DragSource calls continuously while it is being dragged over the drop zone. This method will be called on every mouse movement while the drag source is over the drop zone. It will call onNodeOver while the drag source is over a registered node, and will also automatically delegate to the appropriate node-specific methods as necessary when the drag source enters and exits registered nodes (onNodeEnter, onNodeOut). If the drag source is not currently over a registered node, it will call onContainerOver.
Parameters:

- `source` : Ext.dd.DragSource
  The drag source that was dragged over this drop zone
- `e` : Event
  The event
- `data` : Object
  An object containing arbitrary data supplied by the drag source

Returns:

- `String`
  status The CSS class that communicates the drop status back to the source so that the underlying {@link Ext.dd.StatusProxy} can be updated

DropZone

onAvailable() : void
Override the onAvailable method to do what is needed after the initial position was determined.
Override the onAvailable method to do what is needed after the initial position was determined.
Parameters:

- None.

Returns:

- void

DragDrop

onContainerDrop( `Ext.dd.DragSource source`, `Event e`, `Object data` ) : Boolean
Called when the DropZone determines that a Ext.dd.DragSource has been dropped on it, but not on any of its registered...
Called when the DropZone determines that a Ext.dd.DragSource has been dropped on it, but not on any of its registered drop nodes. The default implementation returns false, so it should be overridden to provide the appropriate processing of the drop event if you need the drop zone itself to be able to accept drops. It should return true when valid so that the drag source's repair action does not run.
Parameters:

- `source` : Ext.dd.DragSource
  The drag source that was dragged over this drop zone
- `e` : Event
  The event
- `data` : Object
  An object containing arbitrary data supplied by the drag source

Returns:

- `Boolean`
  True if the drop was valid, else false

DropZone

onContainerOver( `Ext.dd.DragSource source`, `Event e`, `Object data` ) : String
Called while the DropZone determines that a Ext.dd.DragSource is being dragged over it, but not over any of its regis...
Called while the DropZone determines that a Ext.dd.DragSource is being dragged over it, but not over any of its registered drop nodes. The default implementation returns this.dropNotAllowed, so it should be overridden to provide the proper feedback if necessary.
Parameters:

- `source` : Ext.dd.DragSource
  The drag source that was dragged over this drop zone
- `e` : Event
  The event
- `data` : Object
  An object containing arbitrary data supplied by the drag source

Returns:

- `String`
  status The CSS class that communicates the drop status back to the source so that the underlying {@link Ext.dd.StatusProxy} can be updated

DropZone

onNodeDrop( `Object nodeData`, `Ext.dd.DragSource source`, `Event e`, `Object data` ) : Boolean
Called when the DropZone determines that a Ext.dd.DragSource has been dropped onto the drop node. The default implem...
Called when the DropZone determines that a Ext.dd.DragSource has been dropped onto the drop node. The default implementation returns false, so it should be overridden to provide the appropriate processing of the drop event and return true so that the drag source's repair action does not run.
Parameters:

- `nodeData` : Object
  The custom data associated with the drop node (this is the same value returned from getTargetFromEvent for this node)
- `source` : Ext.dd.DragSource
  The drag source that was dragged over this drop zone
- `e` : Event
  The event
- `data` : Object
  An object containing arbitrary data supplied by the drag source

Returns:

- `Boolean`
  True if the drop was valid, else false

DropZone

onNodeEnter( `Object nodeData`, `Ext.dd.DragSource source`, `Event e`, `Object data` ) : void
Called when the DropZone determines that a Ext.dd.DragSource has entered a drop node that has either been registered ...
Called when the DropZone determines that a Ext.dd.DragSource has entered a drop node that has either been registered or detected by a configured implementation of getTargetFromEvent. This method has no default implementation and should be overridden to provide node-specific processing if necessary.
Parameters:

- `nodeData` : Object
  The custom data associated with the drop node (this is the same value returned from getTargetFromEvent for this node)
- `source` : Ext.dd.DragSource
  The drag source that was dragged over this drop zone
- `e` : Event
  The event
- `data` : Object
  An object containing arbitrary data supplied by the drag source

Returns:

- void

DropZone

onNodeOut( `Object nodeData`, `Ext.dd.DragSource source`, `Event e`, `Object data` ) : void
Called when the DropZone determines that a Ext.dd.DragSource has been dragged out of the drop node without dropping. ...
Called when the DropZone determines that a Ext.dd.DragSource has been dragged out of the drop node without dropping. This method has no default implementation and should be overridden to provide node-specific processing if necessary.
Parameters:

- `nodeData` : Object
  The custom data associated with the drop node (this is the same value returned from getTargetFromEvent for this node)
- `source` : Ext.dd.DragSource
  The drag source that was dragged over this drop zone
- `e` : Event
  The event
- `data` : Object
  An object containing arbitrary data supplied by the drag source

Returns:

- void

DropZone

onNodeOver( `Object nodeData`, `Ext.dd.DragSource source`, `Event e`, `Object data` ) : String
Called while the DropZone determines that a Ext.dd.DragSource is over a drop node that has either been registered or ...
Called while the DropZone determines that a Ext.dd.DragSource is over a drop node that has either been registered or detected by a configured implementation of getTargetFromEvent. The default implementation returns this.dropNotAllowed, so it should be overridden to provide the proper feedback.
Parameters:

- `nodeData` : Object
  The custom data associated with the drop node (this is the same value returned from getTargetFromEvent for this node)
- `source` : Ext.dd.DragSource
  The drag source that was dragged over this drop zone
- `e` : Event
  The event
- `data` : Object
  An object containing arbitrary data supplied by the drag source

Returns:

- `String`
  status The CSS class that communicates the drop status back to the source so that the underlying {@link Ext.dd.StatusProxy} can be updated

DropZone

removeFromGroup( `string sGroup` ) : void
Remove's this instance from the supplied interaction group
Remove's this instance from the supplied interaction group
Parameters:

- `sGroup` : string
  The group to drop

Returns:

- void

DragDrop

setPadding( `int iTop`, `int iRight`, `int iBot`, `int iLeft` ) : void
Configures the padding for the target zone in px. Effectively expands (or reduces) the virtual object size for targe...
Configures the padding for the target zone in px. Effectively expands (or reduces) the virtual object size for targeting calculations. Supports css-style shorthand; if only one parameter is passed, all sides will have that padding, and if only two are passed, the top and bottom will have the first param, the left and right the second.
Parameters:

- `iTop` : int
  Top pad
- `iRight` : int
  Right pad
- `iBot` : int
  Bot pad
- `iLeft` : int
  Left pad

Returns:

- void

DragDrop

toString() : string
toString method
toString method
Parameters:

- None.

Returns:

- `string`
  string representation of the dd obj

DragDrop

unlock() : void
Unlock this instace
Unlock this instace
Parameters:

- None.

Returns:

- void

DragDrop

unreg() : void
Remove all drag and drop hooks for this element
Remove all drag and drop hooks for this element
Parameters:

- None.

Returns:

- void

DragDrop

## Public Events

This class has no public events.